<html>
<head>
  <title>Tableau de bord Balise</title>
  <script src="https://cdn.jsdelivr.net/npm/vega@5"></script>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.9.4/css/bulma.min.css">
</head>
<style>
  html{
    overflow: auto;
  }
</style>
<body>
  <section class="hero is-fullheight is-info" style="min-width: 960px;">
    <div class="hero-body">
    <div id="container" class="container is-fullhd has-text-centered">
      <p class="title">Tableau de bord Balise</p>
      <p class="subtitle">Projet final format AJC - Groupe 4</p>
      <p>Utilisation d'une date fixe <input type="checkbox" id="dtCheck" onclick="change()"/></p>
      <input id="dateRef" style="display: none;" type="datetime-local" onchange="dateChange()"/>

      <div id="dashboard"></div>
      <p class="subtitle">Historique du dernier 1/4  d'heure enregistr&eacute;</p>
      <div id="bme280"></div>
      <p class="subtitle">Statistique sur la derni&egrave;re heure enregistr&eacute;e</p>
      <div class="is-justify-content-center is-flex is-flex-direction-row">
        <div  id="bme_stats"></div>
        <div  id="hcsr501"></div>
      </div>
      
    </div>
  
    </div>
  </section>

  <script type="text/javascript">
    var dashboard;
    var bme280;
    var hcsr501;
    var bme_stats;
    var static_date = false;
    var dateValue = new Date();
    var checkBox = document.getElementById("dtCheck");
    var date = document.getElementById("dateRef");
    var config = {
    "text": {"fill": "#fff", "font-family":"BlinkMacSystemFont,-apple-system,'Segoe UI',Roboto,Oxygen,Ubuntu,Cantarell,'Fira Sans','Droid Sans','Helvetica Neue',Helvetica,Arial,sans-serif;"},
    "title": {"color": "#fff", "subtitleColor": "#fff"},
    "style": {
      "guide-label": {"fill": "#fff"},
      "guide-title": {"fill": "#fff"},
      "title":{"fontSize":14, "fontWeight":"bold"},
      "header": {"fill": "#fdf", "fontSize":12, "fontWeight":"bold"},
      "measures": {"stroke": "#eee"},
      "value": {"fill": "#fff", "fontSize":14}
    },
    "axis": {"domainColor": "#fff", "gridColor": "#888", "tickColor": "#fff"}
};



    fetch('https://gist.githubusercontent.com/mtiberghien/686c45201a0bae54ed53dde0ea70b348/raw/5c6bce5107dde8325ae5782c35a035e8fab998f5/balise_dashboard.vg.json')
      .then(res => res.json())
      .then(spec => render(spec, "dashboard"))
      .then(view => 
      {
        dashboard = view;
        fetch('https://gist.githubusercontent.com/mtiberghien/517adacc656f8df81df58458cdc2c6ea/raw/31dd3881504473c8cebade41d12205d0c36afa09/bme280_histo.vg.json')
      .then(res => res.json())
      .then(spec => render(spec, "bme280"))
      .then(view => 
      {
        bme280 = view;
        fetch('https://gist.githubusercontent.com/mtiberghien/69590d453256889d6838641438ee81ef/raw/764a5576806856870034e2d87703267e49e5a271/hcsr501_stats.vg.json')
      .then(res => res.json())
      .then(spec => render(spec, "hcsr501"))
      .then(view => 
      {
        hcsr501 = view;
        fetch('https://gist.githubusercontent.com/mtiberghien/a484878edf41460da546b650dfa6ae62/raw/ecff7547f231ee3df145f14e5e07f0cd9d9784e7/bme280_stats.vg.json')
      .then(res => res.json())
      .then(spec => render(spec, "bme_stats"))
      .then(view => 
      {
        bme_stats = view;
        get_sensors_values();
      })
      })
      })
      })
      .catch(err => console.error(err));


    function render(spec, name) {
      spec.config = config;
      view = new vega.View(vega.parse(spec), {
        renderer:  'svg',  // renderer (canvas or svg)
        container: '#' + name,   // parent DOM container
        hover:     true       // enable hover processing
      });
      return view.runAsync();
    }

    function get_sensors_values()
    {
      fetch('http://57.128.34.248:1975/api/data/sensors' + (checkBox.checked ? '?time_stamp='+Number(dateValue) : ''))
      .then(res => res.json())
      .then(spec => 
      {
          if(spec)
          {
            return dashboard.data('sensors', spec["values"]).runAsync();
          }
          return null;
      }
      ).then(view =>{
        fetch('http://57.128.34.248:1975/api/data/histo/BME280'+ (checkBox.checked ? '?time_stamp='+Number(dateValue) : ''))
      .then(res => res.json())
      .then(spec => 
      {
          if(spec)
          {
            return bme280.data('sensors', spec["values"]).runAsync();
          }
          return null;
      }
      ).then(view =>{
        fetch('http://57.128.34.248:1975/api/data/stats/HCSR501'+ (checkBox.checked ? '?time_stamp='+Number(dateValue) : ''))
      .then(res => res.json())
      .then(spec => 
      {
          if(spec)
          {
            return hcsr501.data('sensors', spec["values"]).runAsync();
          }
          return null;
          
      }).then(view =>{
        fetch('http://57.128.34.248:1975/api/data/stats/BME280'+ (checkBox.checked ? '?time_stamp='+Number(dateValue) : ''))
      .then(res => res.json())
      .then(spec => 
      {
          if(spec)
          {
            bme_stats.data('sensors', spec["values"]).runAsync();
          }
          if(!static_date)
          {
            setTimeout(get_sensors_values, 4000);
          }
      })
      })
      })
      })
      .catch(err => console.error(err));
    }

    function pad(num, size) {
    var s = "000000000" + num;
    return s.substr(s.length-size);
    }

    function formatDate(d)
    {
      var dformat = [pad(d.getFullYear(),4),
                    pad(d.getMonth()+1,2),
                    pad(d.getDate(),2),
                    ].join('-')+'T'+
                    [pad(d.getHours(),2),
                    pad(d.getMinutes(),2)].join(':');
      return dformat;
    }

    function dateChange()
    {
       dateValue = Date.parse(date.value)/1000;
       get_sensors_values();
    }

    function change()
    {
      static_date = checkBox.checked == true;
      if(!static_date)
      {
        get_sensors_values();
        date.style.display = "none";
      }
      else
      {
        date.value = formatDate(new Date());
        date.style.display = "inline";
      }
    }
  </script>
</body>
</html>